// DoDemo.cpp : Defines the entry point for the application.

#ifndef _WIN32_WCE
#define _WIN32_WINNT 0x0400
#endif

#include "stdafx.h"
#include "resource.h"

extern HINSTANCE hInst;
#include "PrintDC.h"

#if (_WIN32_WCE >= 300)	 && defined(_WIN32_WCE_PSPC)
#include "aygshell.h"
#endif

HWND   hDlgPrint=NULL;
HWND hGlobWnd=NULL;

#define BYTESPERLINE(Width, BPP) ((WORD)((((DWORD)(Width) * (DWORD)(BPP) + 31) >> 5)) << 2)
/********************************************************************** *
Function to load a BMP image from a file to be used by BitBlt or StretchBlt
/********************************************************************** */
HBITMAP CELoadDIBSectionFromBMPFile(LPTSTR szFileName,long* bitwidth,long* bitheight)
{
	HANDLE				hDIBFile;
	BITMAPFILEHEADER	bmfh;
	BITMAPINFO			*pbmi = NULL;
	BITMAPINFOHEADER	bmih;
	BITMAPINFOHEADER *pbmih=NULL;
	DWORD				dwToRead;
	LPBYTE				pBits = NULL;
	HBITMAP				hDIBSection = NULL;
	int colorTblSize;

	hDIBFile = CreateFile(szFileName,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_FLAG_RANDOM_ACCESS,NULL);
	if (hDIBFile == INVALID_HANDLE_VALUE) goto Fail;
	//See if BMP header... if not, see if can try another file type
	if (!ReadFile(hDIBFile,&bmfh,sizeof(bmfh),&dwToRead,NULL ) || bmfh.bfType!=0x4d42) {
		//Move file pointer back to start
		SetFilePointer(hDIBFile,0,NULL,FILE_BEGIN);
		goto Fail;
	}
	// Read the BITMAPINFOHEADER
	if (!ReadFile ( hDIBFile, &bmih, sizeof(bmih), &dwToRead, NULL )) goto Fail;
	if (bmih.biClrUsed != 0 ) colorTblSize = bmih.biClrUsed;
	else if (bmih.biBitCount > 8 ) colorTblSize = 0;
	else colorTblSize = 1 << (bmih.biBitCount * bmih.biPlanes);
	colorTblSize*=sizeof(RGBQUAD);

	pbmi = (BITMAPINFO *) LocalAlloc(LPTR,sizeof(bmih) + colorTblSize);
	pbmih=&pbmi->bmiHeader;
	memcpy(pbmih,&bmih,sizeof(bmih));

	// Read the Color Table
	if (colorTblSize>0) {
		if (!ReadFile(hDIBFile,pbmi->bmiColors,colorTblSize,&dwToRead,NULL)) goto Fail;
	}
	hDIBSection = CreateDIBSection(NULL,pbmi,DIB_RGB_COLORS,(void**)&pBits,NULL,0);
	if (hDIBSection == NULL) goto Fail;
	if (pbmih->biSizeImage == 0) {
		pbmih->biSizeImage =  BYTESPERLINE(pbmi->bmiHeader.biWidth,pbmi->bmiHeader.biBitCount*pbmi->bmiHeader.biPlanes)*pbmi->bmiHeader.biHeight;
	}
	*bitwidth=pbmih->biWidth;
	*bitheight=pbmih->biHeight;

	// Read the bitmap definition.
	SetFilePointer ( hDIBFile, bmfh.bfOffBits, NULL, FILE_BEGIN );
	if (!ReadFile ( hDIBFile, pBits, pbmih->biSizeImage,&dwToRead, NULL )) goto Fail;
	CloseHandle(hDIBFile);
	if (pbmi) LocalFree(pbmi);
	return hDIBSection;

Fail:
	if (hDIBSection) DeleteObject(hDIBSection);
	if (pbmi) LocalFree(pbmi);
	if (hDIBFile!= INVALID_HANDLE_VALUE) CloseHandle(hDIBFile);
	return NULL;
} //CELoadDIBSectionFromBMPFile()


BOOL   bUserAbort=FALSE;
//---------------------------------------------------------------------
// To process the "Printing in Progress" dialog, all we need to look for is Cancel key
//---------------------------------------------------------------------
BOOL CALLBACK PrintDlgProc (HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam) {
	switch (msg) {
	case WM_COMMAND :
		bUserAbort = TRUE ;
		return TRUE ;
	}
	return FALSE ;
}

//---------------------------------------------------------------------
//---------------------------------------------------------------------
BOOL CALLBACK MyAbortProc (HDC hdcPrn, int iCode)
{
	MSG   msg ;
	while (!bUserAbort && PeekMessage (&msg, NULL, 0, 0, PM_REMOVE)) {
		if (!hDlgPrint || !IsDialogMessage (hDlgPrint, &msg)) {
			TranslateMessage (&msg) ;
			DispatchMessage (&msg) ;
		}
	}
	return !bUserAbort ;
}

//Set up text array to be printed...
LPTSTR SampleText[] = {
	TEXT("PrinterCE Plus for Pocket PC and Windows CE"),
	TEXT(" - eVB/VBCE and eVC (C/C++/MFC) development environments"),
	TEXT(" - Versions for Pocket PC, PsPC, HPC2000 and HPC/Pro platforms"),
	TEXT(" - Easy to use - no device contexts, bitblits or other complexities"),
	TEXT(" - Powerful..."),
	TEXT("   * Text - Select font, size, style, rotation, page position..."),
	TEXT("   * Images - BMP, JPG - Select size, aspect ratio, rotation..."),
	TEXT("      + Plus GIF & PNG image support for the Pocket PC"),
	TEXT("   * Objects - Lines, ellipses, rectangles, rounded rectangles..."),
	TEXT("   * Much More!!!"),
	TEXT(" - AsciiCE  - Fast Ascii-text printing for ANY Ascii printer"),
	TEXT(" - PrintDC  - Port standard Windows printing code"),
	TEXT(" - Optional - Barcode version supports over a dozen barcode types"),
	TEXT(" - Flexible pricing to fit budgets of small, medium & large projects"),
	TEXT(" "),
	TEXT(" Printers Supported:"),
	TEXT("   * Pentax PocketJet Portable printers"),
	TEXT("   * HP PCL3 - Most HP DeskJet, LaserJet & compatible printers"),
	TEXT("   * Canon BubbleJet and compatible printers"),
	TEXT("   * Epson - ESC/P2, Stylus, 24-pin and LQ compatible printers"),
	TEXT("   * Seiko DPU-3445"),
	TEXT("   * Citizen PD-04 & PN60i"),
	TEXT("   * O'Neil MicroFlash"),
	TEXT("   * Extech"),
	TEXT("   * More..."),
	TEXT(" "),
	TEXT(" Visit at http://www.fieldsoftware.com/PrinterCE.htm"),
	TEXT(" - Free 60-day full-function evaluation"),
	TEXT(" - Documentation & sample source code"),
	TEXT(" - Pricing and purchasing info"),
};

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
void Test_PrintDC(HWND hGlobWnd,HINSTANCE hGlobInst)
{
	PRINTDLG pdlg;
	DOCINFO di;
	int curPgWidth;
	int curPgHeight;
	int x;
	int y;
	int curPgLmgn,curPgTmgn,curPgRmgn,curPgBmgn;
	LOGFONT logfont;
	HFONT hFontOld=NULL;
	HFONT hFontPrint=NULL;
	HDC hPrDC=NULL;
	HPEN hPen1=NULL;
	HPEN hPen2=NULL;
	HPEN hPen3=NULL;
	HPEN savPen=NULL;
	HBRUSH hBrush1=NULL;
	HBRUSH savBrush=NULL;
	LPTSTR lpStr;
	int PrinterDPI;
	int cyChar;
	int cxChar;
	int ival;
	HBITMAP hBitmap,hOldBmp;
	DIBSECTION db;
	HDC hdcMem;
	int slen;
	SIZE size;
	int linecnt,maxlinelen,index,lp,tmp;

	int rval;
	DWORD dval;

	bUserAbort=FALSE;
	hDlgPrint = CreateDialog(hGlobInst, (LPCTSTR)IDD_ABORTPROC, hGlobWnd, PrintDlgProc) ;
	if (hDlgPrint==NULL) {
		goto AbortErr;
	}
	ival=ShowWindow(hDlgPrint, SW_SHOWNORMAL);      // Standard show and update calls

	//Initialize PrintDC
	PDC_Init(_T("YOUR LICENSE KEY"));

	// Let user select printer
	memset(&pdlg, 0, sizeof(PRINTDLG));
	pdlg.cbStruct = sizeof(PRINTDLG);
	pdlg.hwndOwner=  hGlobWnd;
	pdlg.dwFlags = PD_SELECTPORTRAIT | PD_INTHOUSANDTHSOFINCHES;
	if (!PDC_PrintDlg(&pdlg)) {
		goto AbortErr;
	}
	curPgLmgn=pdlg.rcMargin.left;
	curPgTmgn=pdlg.rcMargin.top;
	curPgRmgn=pdlg.rcMargin.right;
	curPgBmgn=pdlg.rcMargin.bottom;

	//Get the printer DC
	hPrDC=PDC_GetPrinterDC();

	//If we were successful putting the "Printing in Progress" dialog, set it as our Abort proc
	if (hDlgPrint) {
		ival=ShowWindow(hDlgPrint, SW_SHOWNORMAL);      // Standard show and update calls
		PDC_SetAbortProc(hPrDC,(ABORTPROC) MyAbortProc);
	}

	//Get printer resolution
	PrinterDPI=PDC_GetDeviceCaps((HDC) hPrDC,LOGPIXELSX);

	//Get page dimensions and margin settings
	int physX,physY;
	physX=PDC_GetDeviceCaps(hPrDC,PHYSICALOFFSETX);
	physY=PDC_GetDeviceCaps(hPrDC,PHYSICALOFFSETY);

	curPgLmgn  =(pdlg.rcMargin.left*PrinterDPI)/1000 - physX;
	curPgRmgn =(pdlg.rcMargin.right*PrinterDPI)/1000 + physX;
	curPgTmgn   =(pdlg.rcMargin.top*PrinterDPI)/1000 - physY;
	curPgBmgn=(pdlg.rcMargin.bottom*PrinterDPI)/1000 + physY;

	if (curPgLmgn<physX) curPgLmgn=physX;
	if (curPgTmgn<physY) curPgTmgn=physY;
	if (curPgRmgn<physX) curPgRmgn=physX;
	if (curPgBmgn<physY) curPgBmgn=physY;
	curPgWidth  = PDC_GetDeviceCaps(hPrDC,PHYSICALWIDTH)-(curPgLmgn+curPgRmgn);
	curPgHeight = PDC_GetDeviceCaps(hPrDC,PHYSICALHEIGHT)-(curPgTmgn+curPgBmgn);


	hPen1=CreatePen(PS_SOLID,10,RGB(0xff,0,0));
	hPen2=CreatePen(PS_DASH,20,RGB(0xFF,0,0xFF));
	hPen3=CreatePen(PS_SOLID,5,RGB(0xff,0xff,0));
	hBrush1=CreateSolidBrush(RGB(0,0xFF,0));
	savPen=(HPEN) PDC_SelectObject(hPrDC,(HGDIOBJ) hPen1);
	savBrush=(HBRUSH) PDC_SelectObject(hPrDC,(HGDIOBJ) hBrush1);

	//Lets get started printing
	PDC_StartDoc(hPrDC,&di);
	PDC_StartPage(hPrDC);
	x = curPgLmgn;
	y = curPgTmgn;

	//Print a rectangle at top of page - full page width
	PDC_SetBkMode(hPrDC,OPAQUE);
	PDC_SelectObject(hPrDC,(HGDIOBJ) hPen2);
	PDC_SelectObject(hPrDC,(HGDIOBJ) hBrush1);
	PDC_Rectangle(hPrDC,curPgLmgn,curPgTmgn,curPgLmgn+2*PrinterDPI,curPgTmgn+PrinterDPI/2);

	//Draw some other things
	PDC_SelectObject(hPrDC,(HGDIOBJ) hPen3);
	PDC_Ellipse(hPrDC,x+(3*PrinterDPI)/2,y+PrinterDPI/3,x+PrinterDPI*2,y+PrinterDPI);

	lpStr=_T("Hello World");
	slen=_tcslen(lpStr);
	PDC_SetBkMode(hPrDC,TRANSPARENT);
	PDC_ExtTextOut(hPrDC,curPgLmgn+PrinterDPI/2, curPgTmgn+PrinterDPI/5, 0, NULL, lpStr, slen, NULL);

	//Draw a bitmap
	long imageWd,imageHt;
	hBitmap=CELoadDIBSectionFromBMPFile(_T("\\Images\\Owl.bmp"),&imageWd,&imageHt);
	if (hBitmap) {
		hdcMem=PDC_CreateCompatibleDC(hPrDC);
		hOldBmp=(HBITMAP) PDC_SelectObject(hdcMem,(HGDIOBJ) hBitmap);
		GetObject(hBitmap,sizeof(DIBSECTION),&db);
		//Stretch bitmap to keep aspect ratio and fit within box 2" wide x 1" high
		long stretchWd,stretchHt;
		stretchWd=(3*PrinterDPI)/2;
		stretchHt=(stretchWd*imageHt)/imageWd;
		if (stretchHt>(3*PrinterDPI)/2) {
			stretchHt=(3*PrinterDPI)/2;
			stretchWd=(stretchHt*imageWd)/imageHt;
		}
		
		PDC_StretchBlt(hPrDC,x+(9*PrinterDPI)/4,y,stretchWd,stretchHt,hdcMem,0,0,imageWd,imageHt,SRCCOPY);
		PDC_SelectObject(hdcMem,(HGDIOBJ) hOldBmp);
		PDC_DeleteDC(hdcMem);
		DeleteObject(hBitmap);
	}

	//Draw a triangle using PolyLine
	PDC_SelectObject(hPrDC,(HGDIOBJ) hPen1);
	{
		POINT ptarray[4] = {
			{curPgLmgn+PrinterDPI,curPgTmgn+PrinterDPI/2},
			{curPgLmgn+PrinterDPI/2,curPgTmgn+(3*PrinterDPI)/2},
			{curPgLmgn+(3*PrinterDPI)/2,curPgTmgn+(3*PrinterDPI)/2},
			{curPgLmgn+PrinterDPI,curPgTmgn+PrinterDPI/2}};
		PDC_Polyline(hPrDC,ptarray,4);
	}

	//Now lets look at the text in "SampleText" array (above) and calculate largest font
	// size that will let us fit text both vertically and horizontally in open area of page
	y=curPgTmgn+(7*PrinterDPI)/4;
	//Number of lines to print
	linecnt=sizeof(SampleText)/sizeof(LPTSTR);
	maxlinelen=0;
	index=0;
	//Find longest text string in SampleText
	for (lp=0;lp<linecnt;lp++) {
		tmp=_tcslen(SampleText[lp]);
		if (tmp>maxlinelen) {
			maxlinelen=tmp;
			index=lp;
		}
	}
	//Starting font height is height of open area divided by # lines text in SampleText
	cyChar = (curPgHeight-y-PrinterDPI/2) / linecnt;
	cxChar = cyChar/2;

	memset(&logfont,0,sizeof(logfont));
	logfont.lfWeight = FW_NORMAL;
	logfont.lfEscapement = 0;
	logfont.lfOrientation = 0;
	logfont.lfItalic = FALSE;
	logfont.lfUnderline = FALSE;
	logfont.lfStrikeOut = FALSE;
	logfont.lfCharSet = ANSI_CHARSET;
	logfont.lfOutPrecision = OUT_DEFAULT_PRECIS;
	logfont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	logfont.lfQuality = DRAFT_QUALITY;
	logfont.lfPitchAndFamily = TRUETYPE_FONTTYPE;
	_tcscpy(logfont.lfFaceName, TEXT("Tahoma"));
	logfont.lfHeight = cyChar;
	logfont.lfWidth = cxChar;
	hFontPrint = CreateFontIndirect(&logfont);
	hFontOld = (HFONT) PDC_SelectObject(hPrDC,hFontPrint);

	// Iterate until a font is found that fits longest text string horizontally
	while (TRUE) {
		PDC_GetTextExtentExPoint(hPrDC,SampleText[index],maxlinelen,0,NULL,NULL,&size);
		if (size.cx<=curPgWidth) break;
		// Get rid of font and try again
		DeleteObject(hFontPrint);
		tmp = ((cxChar * curPgWidth) + curPgWidth/2) / size.cx;
		if (tmp>=cxChar) cxChar--;
		else cxChar=tmp;
		if (cxChar<=0) break;
		cyChar = cxChar * 2;

		logfont.lfHeight = cyChar;
		logfont.lfWidth = cxChar;
		hFontPrint = CreateFontIndirect(&logfont);
		PDC_SelectObject(hPrDC,hFontPrint);
	}
	cyChar=size.cy;
	
	x=curPgLmgn;
	//Now ready to print out SampleText
	for (lp=0;lp<linecnt;lp++) {
		slen=_tcslen(SampleText[lp]);
		PDC_ExtTextOut(hPrDC,curPgLmgn, y, 0, NULL, SampleText[lp], slen, NULL);
		y+=cyChar;
	}

	//We're done... lets finish up
	rval=PDC_EndPage(hPrDC);
	dval=PDC_GetLastError();
	rval=PDC_EndDoc(hPrDC);
	dval=PDC_GetLastError();
AbortErr:
	//Delete our Pens
	if (savPen) PDC_SelectObject(hPrDC,(HGDIOBJ) savPen);
	if (hPen1) DeleteObject(hPen1);
	if (hPen2) DeleteObject(hPen2);
	if (hPen3) DeleteObject(hPen3);

	//Delete our Brushes
	if (savBrush) PDC_SelectObject(hPrDC,(HGDIOBJ) savBrush);
	if (hBrush1) DeleteObject(hBrush1);
	
	//Delete our Fonts
	if (hFontOld) PDC_SelectObject(hPrDC,hFontOld);
	if (hFontPrint) DeleteObject(hFontPrint);

	if (hDlgPrint) {
		EnableWindow (hGlobWnd, TRUE) ;     
		DestroyWindow(hDlgPrint) ;
		hDlgPrint=NULL;
		ShowWindow(hGlobWnd, SW_SHOWNORMAL);      // Standard show and update calls
	}
	if (hPrDC) PDC_DeleteDC((HDC) hPrDC);
}

/*********************************************************
*********************************************************/
// Mesage handler for the Demo box.
LRESULT CALLBACK Demo(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
//	DWORD errVal;
	int ival;
	switch (message)
	{
		case WM_INITDIALOG:
			{
				hGlobWnd=hDlg;
#if (_WIN32_WCE >= 300)	 && defined(_WIN32_WCE_PSPC)
				SHINITDLGINFO shidi;
				// Create a Done button and size it.
				shidi.dwMask = SHIDIM_FLAGS;
				shidi.dwFlags = SHIDIF_SIZEDLG | SHIDIF_SIPDOWN;
				shidi.hDlg = hDlg;
				SHInitDialog(&shidi);
#endif
				//Display PrintDC's version number on our dialog box
				long ver;
				ver=PDC_GetVersion();
				TCHAR buffer[] = _T("PrinterCE/PrintDC v0.00");
				ver/=10;
				buffer[22]='0'+(BYTE) (ver%10);
				ver/=10;
				buffer[21]='0'+(BYTE) (ver%10);
				ver/=10;
				buffer[19]='0'+(BYTE) (ver%10);
				SendMessage(GetDlgItem(hDlg,IDC_PRINTERCEVERSION),WM_SETTEXT,0,(LPARAM) buffer);
			}
			return TRUE;
		case WM_PAINT:
			//NOTE: Without the SetFocus(), the "Done" OK button goes away if select Today and then back to here
			SetFocus(hDlg);
			HWND hpwnd;
			hpwnd=GetParent(hDlg);
			if (hpwnd) ::UpdateWindow(hpwnd);
			return FALSE;
		case WM_COMMAND:
			ival=LOWORD(wParam);
			switch (ival) {
			case IDCANCEL:
				EndDialog(hDlg, ival);
				return TRUE;
			case IDC_PRINTDC:
				Test_PrintDC(hDlg,hInst);
				return TRUE;
			}
			break;
	}
	return FALSE;
}

/*********************************************************
*********************************************************/
void DoDemo(HWND hWnd)
{
	DialogBox(hInst, (LPCTSTR)IDD_DEMO, hWnd, (DLGPROC)Demo);
}

